
LOG=/tmp/spokes.log

HOMEBREW_PREFIX=/usr/local

echo "Spokes-tarball-dir: $SPOKES_DIR" >> $LOG
echo "User: $USER" >> $LOG
echo "Group: $GID" >> $LOG

###
# prune and remove older scripts, templates, etc...
###
if [ -d $HOMEBREW_PREFIX/var/spokes ]; then
	rm -rf $HOMEBREW_PREFIX/var/spokes > /dev/null
fi

###
# create all of the base directories for our installation.
###
install -d -m 755 $HOMEBREW_PREFIX/etc/spokes
install -d -m 755 $HOMEBREW_PREFIX/var/lib/spokes
install -d -m 755 $HOMEBREW_PREFIX/var/lib/spokes/licenses
install -d -m 755 $HOMEBREW_PREFIX/var/lib/spokes/sessions
install -d -m 755 $HOMEBREW_PREFIX/var/log/spokes
# install -d -m 755 $HOMEBREW_PREFIX/opt/spokes &>> $LOG

###
# setup etc and configuration dir
###
install -m 644 etc/spokes/config.json.example \
	$HOMEBREW_PREFIX/etc/spokes/config.json.example

# ###
# # remove any past artifacts (template, htdocs) that can cause
# # problems when performing upgrades.
# ###
# rm -rf $HOMEBREW_PREFIX/opt/spokes/htdocs     &> /dev/null
# rm -rf $HOMEBREW_PREFIX/opt/spokes/templates  &> /dev/null
# rm -rf $HOMEBREW_PREFIX/opt/spokes/migrations &> /dev/null

# ###
# # update HTML templates, static assets and migrations scripts
# ###
# cp -R usr/share/spokes/* $HOMEBREW_PREFIX/opt/spokes/ &>> $LOG

# copy latest empty database into var/lib/spokes
install -m 644 var/lib/spokes/spokes.db.empty $HOMEBREW_PREFIX/var/lib/spokes/spokes.db.empty

###
# backup existing database
###
if [ -f $HOMEBREW_PREFIX/var/lib/spokes/spokes.db ]; then
	TIMESTAMP=$(date +"%Y-%m-%d_%H:%M:%S")
	DB_BACKUP=spokes.db.$TIMESTAMP
	cp $HOMEBREW_PREFIX/var/lib/spokes/spokes.db $HOMEBREW_PREFIX/var/lib/spokes/$DB_BACKUP
else
	cp $HOMEBREW_PREFIX/var/lib/spokes/spokes.db.empty $HOMEBREW_PREFIX/var/lib/spokes/spokes.db
fi

###
# run database migration scripts
###
cat $HOMEBREW_PREFIX/var/spokes/migrations/v0.9.13_tunnel_client_version.sql | \
	sqlite3 $HOMEBREW_PREFIX/var/lib/spokes/spokes.db &> /dev/null

cat $HOMEBREW_PREFIX/var/spokes/migrations/v1.0.3_one_time_passcodes.sql | \
	sqlite3 $HOMEBREW_PREFIX/var/lib/spokes/spokes.db &> /dev/null

cat $HOMEBREW_PREFIX/var/spokes/migrations/v1.0.4_messages.sql | \
	sqlite3 $HOMEBREW_PREFIX/var/lib/spokes/spokes.db &> /dev/null

cat $HOMEBREW_PREFIX/var/spokes/migrations/v1.1.0_domains.sql | \
	sqlite3 $HOMEBREW_PREFIX/var/lib/spokes/spokes.db &> /dev/null

###
# Finished
###
exit 0
